Index: /code/branches/cegui0.8_ogre1.9/data/levels/presentationFS11.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/presentationFS11.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/presentationFS11.oxw	(revision 11795)
@@ -111,5 +111,5 @@
 
     <!-- EARTH -->
-    <Planet
+    <MovableEntity
       position="80500,0,0"
       scale="63000"
@@ -120,20 +120,25 @@
       pitch="-90"
       yaw="50"
-      mesh="planets/earth.mesh"
-      atmosphere="atmosphere1"
       rotationaxis="0,1,0"
       rotationrate="0.2"
-      atmospheresize="80.0f"
-      imagesize="1024.0f"
       collisiondamage = 2
       enablecollisiondamage = true
     >
       <attached>
-        <ForceField position="0,0,0" mode="newtonianGravity" diameter="140000" massDiameter="126000" mass="5.9e21" />
+        <Planet
+          mesh="planets/earth.mesh"
+          atmosphere="atmosphere1"
+          atmospheresize="80.0f"
+          imagesize="1024.0f"
+        >
+          <attached>
+            <ForceField position="0,0,0" mode="newtonianGravity" diameter="140000" massDiameter="126000" mass="5.9e21" />
+          </attached>
+        </Planet>
       </attached>
       <collisionShapes>
         <SphereCollisionShape radius="63000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <!-- PARTICLE EFFECT -->
@@ -329,5 +334,5 @@
     
     <!-- MOON -->
-    <Planet
+    <MovableEntity
       position="-80000,0,0"
       scale="4000"
@@ -337,20 +342,25 @@
       mass="7.36e19"
       pitch="0"
-      mesh="planets/moon.mesh"
-      atmosphere="atmosphere1"
       rotationaxis="0,1,0"
       rotationrate="0.2"
-      atmospheresize="0.0f"
-      imagesize="1024.0f"
       collisiondamage = 2
       enablecollisiondamage = true
     >
       <attached>
-        <ForceField position="0,0,0" mode="newtonianGravity" diameter="40000" massDiameter="34740" mass="7.36e19" />
+        <Planet
+          mesh="planets/moon.mesh"
+          atmosphere="atmosphere1"
+          atmospheresize="0.0f"
+          imagesize="1024.0f"
+        >
+          <attached>
+            <ForceField position="0,0,0" mode="newtonianGravity" diameter="40000" massDiameter="34740" mass="7.36e19" />
+          </attached>
+        </Planet>
       </attached>
       <collisionShapes>
         <SphereCollisionShape radius="4000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <SimpleNotification message="Hydrogen farmer/space station by Hans" >
Index: /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS09.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS09.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS09.oxw	(revision 11795)
@@ -393,8 +393,4 @@
       </MovableEntity>
     <?lua end ?>
-    
-<!--
-    <Planet position="1000,0,0" mass=900000 scale=1000 pitch=-90 mesh="iceplanet.mesh" atmosphere="atmosphere1" rotationaxis="1,1,0" rotationrate="1" atmospheresize=224.0f imagesize=1024.0f />
--->
 
   </Scene>
Index: /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS12.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS12.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/presentationHS12.oxw	(revision 11795)
@@ -353,5 +353,5 @@
     ?>
 
-    <Planet
+    <MovableEntity
       position="15000,0,-1000"
       scale="5000"
@@ -361,20 +361,25 @@
       mass="10000000"
       pitch="0"
-      mesh="planets/ganymede.mesh"
-      atmosphere="atmosphere1"
       rotationaxis="1,0,0"
       rotationrate="1.0"
-      atmospheresize="80.0f"
-      imagesize="1024.0f"
       collisiondamage = 2
       enablecollisiondamage = true
     >
       <attached>
-        <ForceField position="5000,0,0" mode="sphere" diameter="10000" velocity="-50" />
+        <Planet
+          mesh="planets/ganymede.mesh"
+          atmosphere="atmosphere1"
+          atmospheresize="80.0f"
+          imagesize="1024.0f"
+        >
+          <attached>
+            <ForceField position="5000,0,0" mode="sphere" diameter="10000" velocity="-50" />
+          </attached>
+        </Planet>
       </attached>
       <collisionShapes>
         <SphereCollisionShape radius="5000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
 <StaticEntity position="6750,-750,2000" yaw=0 pitch=0>
Index: /code/branches/cegui0.8_ogre1.9/data/levels/shadertest.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/shadertest.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/shadertest.oxw	(revision 11795)
@@ -78,5 +78,5 @@
     <!-- Planet close to spawn point -->
 
-    <Planet
+    <MovableEntity
       position="15000,0,-1000"
       scale="5000"
@@ -86,20 +86,25 @@
       mass="10000000"
       pitch="0"
-      mesh="planets/muunilinst.mesh"
-      atmosphere="atmosphere1"
       rotationaxis="1,0,0"
       rotationrate="1.0"
-      atmospheresize="80.0f"
-      imagesize="1024.0f"
       collisiondamage = 2
       enablecollisiondamage = true
     >
       <attached>
-        <ForceField position="5000,0,0" mode="sphere" diameter="10000" velocity="-50" />
+        <Planet
+          mesh="planets/muunilinst.mesh"
+          atmosphere="atmosphere1"
+          atmospheresize="80.0f"
+          imagesize="1024.0f"
+        >
+          <attached>
+            <ForceField position="5000,0,0" mode="sphere" diameter="10000" velocity="-50" />
+          </attached>
+        </Planet>
       </attached>
       <collisionShapes>
         <SphereCollisionShape radius="5000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
 
Index: /code/branches/cegui0.8_ogre1.9/data/levels/shuttleAttack.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/shuttleAttack.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/shuttleAttack.oxw	(revision 11795)
@@ -930,5 +930,5 @@
     ?>
 
-    <Planet
+    <MovableEntity
         position="<?lua printC(cPlanet1) ?>"
         scale="2000"
@@ -938,20 +938,25 @@
         mass="5000000"
         pitch="0"
-        mesh="planets/muunilinst.mesh"
-        atmosphere="atmosphere1"
         rotationaxis="1,0,0"
         rotationrate="1.0"
-        atmospheresize="80.0f"
-        imagesize="1024.0f"
         collisiondamage = 2
         enablecollisiondamage = true
-      >
+    >
       <attached>
-        <ForceField position="0,0,0" mode="sphere" diameter="4000" velocity="-500" />
-        </attached>
-          <collisionShapes>
-            <SphereCollisionShape radius="2000" position="0,0,0" />
+        <Planet
+            mesh="planets/muunilinst.mesh"
+            atmosphere="atmosphere1"
+            atmospheresize="80.0f"
+            imagesize="1024.0f"
+        >
+          <attached>
+            <ForceField position="0,0,0" mode="sphere" diameter="4000" velocity="-500" />
+          </attached>
+        </Planet>
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="2000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <?lua
@@ -960,5 +965,5 @@
     ?>
 
-    <Planet
+    <MovableEntity
         position="<?lua printC(cPlanet2) ?>"
         scale="3000"
@@ -968,20 +973,25 @@
         mass="5000000"
         pitch="0"
-        mesh="planets/planet3.mesh"
-        atmosphere="atmosphere1"
         rotationaxis="1,0,0"
         rotationrate="1.0"
-        atmospheresize="80.0f"
-        imagesize="1024.0f"
         collisiondamage = 2
         enablecollisiondamage = true
-      >
+    >
       <attached>
-        <ForceField position="0,0,0" mode="sphere" diameter="6000" velocity="-500" />
-        </attached>
-          <collisionShapes>
-            <SphereCollisionShape radius="3000" position="0,0,0" />
+        <Planet
+            mesh="planets/planet3.mesh"
+            atmosphere="atmosphere1"
+            atmospheresize="80.0f"
+            imagesize="1024.0f"
+          >
+          <attached>
+            <ForceField position="0,0,0" mode="sphere" diameter="6000" velocity="-500" />
+          </attached>
+        </Planet>
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="3000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <?lua
Index: /code/branches/cegui0.8_ogre1.9/data/levels/shuttleRetaliation.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/shuttleRetaliation.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/shuttleRetaliation.oxw	(revision 11795)
@@ -880,5 +880,5 @@
     <!-- Planets -->
 
-   <Planet
+    <MovableEntity
         position="<?lua printC(cPlanet1) ?>"
         scale="3000"
@@ -888,22 +888,27 @@
         mass="5000000"
         pitch="0"
-        mesh="planets/muunilinst.mesh"
-        atmosphere="atmosphere1"
         rotationaxis="1,0,0"
         rotationrate="1.0"
-        atmospheresize="80.0f"
-        imagesize="1024.0f"
         collisiondamage = 2
         enablecollisiondamage = true
-    visible=true
-    active=true
-      >
+    >
       <attached>
-        <ForceField position="0,0,0" mode="sphere" diameter="6000" velocity="-500" />
-        </attached>
-        <collisionShapes>
-            <SphereCollisionShape radius="3000" position="0,0,0" />
+        <Planet
+            mesh="planets/muunilinst.mesh"
+            atmosphere="atmosphere1"
+            atmospheresize="80.0f"
+            imagesize="1024.0f"
+            visible=true
+            active=true
+        >
+          <attached>
+            <ForceField position="0,0,0" mode="sphere" diameter="6000" velocity="-500" />
+          </attached>
+        </Planet>
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="3000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <?lua
@@ -912,5 +917,5 @@
     ?>
 
-    <Planet
+    <MovableEntity
         position="<?lua printC(cPlanet2) ?>"
         scale="2000"
@@ -920,22 +925,27 @@
         mass="5000000"
         pitch="0"
-        mesh="planets/ganymede.mesh"
-        atmosphere="atmosphere1"
         rotationaxis="1,0,0"
         rotationrate="1.0"
-        atmospheresize="80.0f"
-        imagesize="1024.0f"
         collisiondamage = 2
         enablecollisiondamage = true
-        visible=true
-        active=true
-      >
+    >
       <attached>
-        <ForceField position="0,0,0" mode="sphere" diameter="4000" velocity="-500" />
-        </attached>
-          <collisionShapes>
-            <SphereCollisionShape radius="2000" position="0,0,0" />
+        <Planet
+            mesh="planets/ganymede.mesh"
+            atmosphere="atmosphere1"
+            atmospheresize="80.0f"
+            imagesize="1024.0f"
+            visible=true
+            active=true
+        >
+          <attached>
+            <ForceField position="0,0,0" mode="sphere" diameter="4000" velocity="-500" />
+          </attached>
+        </Planet>
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="2000" position="0,0,0" />
       </collisionShapes>
-    </Planet>
+    </MovableEntity>
 
     <?lua
@@ -946,5 +956,5 @@
     <!-- EnemyPlanet -->
 
-    <Planet
+    <MovableEntity
         position="<?lua printC(cEnemyBasePlanet) ?>"
         scale="5000"
@@ -954,19 +964,22 @@
         mass="5000000"
         pitch="0"
-        mesh="planets/jupiter.mesh"
-        atmosphere="atmosphere1"
         rotationaxis="1,0,0"
         rotationrate="1.0"
-        atmospheresize="80.0f"
-        imagesize="1024.0f"
         collisiondamage = 2
         enablecollisiondamage = true
-        visible=false
-        active=false
     >
-        <attached>
+      <attached>
+        <Planet
+            mesh="planets/jupiter.mesh"
+            atmosphere="atmosphere1"
+            atmospheresize="80.0f"
+            imagesize="1024.0f"
+            visible=false
+            active=false
+        >
+          <attached>
            <ForceField position="0,0,0" rotationaxis="0.1,1,0.1"mode="sphere" diameter="10000" velocity="-500" />
-        </attached>
-        <events>
+          </attached>
+          <events>
             <activity>
                 <Trigger  name="enemyPlanetVisible" mode=and>
@@ -1005,9 +1018,11 @@
                  </Trigger>
             </visibility>
-        </events>
-        <collisionShapes>
-          <SphereCollisionShape position="0,0,0" radius=5000/>
-        </collisionShapes>
-    </Planet>
+          </events>
+        </Planet>
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape position="0,0,0" radius=5000/>
+      </collisionShapes>
+    </MovableEntity>
 
     <!-- Pawn that represents the planet during destruction -->
Index: /code/branches/cegui0.8_ogre1.9/data/levels/testSwallow.oxw
===================================================================
--- /code/branches/cegui0.8_ogre1.9/data/levels/testSwallow.oxw	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/data/levels/testSwallow.oxw	(revision 11795)
@@ -56,5 +56,9 @@
 ?>
 <?lua end ?>
-    <Planet position="0,0,0" scale=10000 pitch=-90 mesh="iceplanet.mesh" atmosphere="atmosphere1" rotationaxis="1,1,0" rotationrate="1" atmospheresize=224.0f imagesize=1024.0f />
+    <MovableEntity position="0,0,0" scale=10000 pitch=-90 rotationaxis="1,1,0" rotationrate="1" >
+      <attached>
+        <Planet mesh="iceplanet.mesh" atmosphere="atmosphere1" atmospheresize=224.0f imagesize=1024.0f />
+      </attached>
+    </MovableEntity>
 
   </Scene>
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/core/CMakeLists.txt
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/core/CMakeLists.txt	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/core/CMakeLists.txt	(revision 11795)
@@ -95,4 +95,5 @@
   LINK_LIBRARIES
     ${OGRE_LIBRARY}
+    ${OGRE_OVERLAY_LIBRARY}
     ${Boost_FILESYSTEM_LIBRARY}
     ${Boost_SYSTEM_LIBRARY} # Filesystem dependency
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/core/GUIManager.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/core/GUIManager.cc	(revision 11795)
@@ -482,4 +482,7 @@
         assert(guiSystem_);
         this->protectedCeguiSystemCall(std::bind(&CEGUI::System::injectTimePulse, arg::_1, time.getDeltaTime()));
+#if CEGUI_VERSION >= 0x000800
+        this->protectedCeguiContextCall(std::bind(&CEGUI::GUIContext::injectTimePulse, arg::_1, time.getDeltaTime()));
+#endif
     }
 
@@ -664,5 +667,5 @@
             this->setBackgroundImage("");
         else
-            this->setBackgroundImage("set: " + imageSet + " image: " + imageName);
+            this->setBackgroundImage(imageSet + "/" + imageName);
     }
 
@@ -846,5 +849,5 @@
     bool GUIManager::protectedCeguiContextCall(FunctionType function)
     {
-        return this->protectedCall(function, this->guiSystem_->getDefaultGUIContext());
+        return this->protectedCall(function, &this->guiSystem_->getDefaultGUIContext());
     }
 #endif
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.cc	(revision 11795)
@@ -45,4 +45,7 @@
 #include <OgreViewport.h>
 #include <OgreWindowEventUtilities.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreOverlaySystem.h>
+#endif
 
 #include "SpecialConfig.h"
@@ -115,4 +118,10 @@
         this->loadOgreRoot();
 
+#if OGRE_VERSION >= 0x010900
+        this->overlaySystem_ = new Ogre::OverlaySystem();
+#else
+        this->overlaySystem_ = nullptr;
+#endif
+
         // At first, add the root paths of the data directories as resource locations
         Ogre::ResourceGroupManager::getSingleton().addResourceLocation(ConfigurablePaths::getDataPathString(), "FileSystem");
@@ -155,4 +164,7 @@
         Loader::getInstance().unload(extResources_.get());
 
+#if OGRE_VERSION >= 0x010900
+        safeObjectDelete(&overlaySystem_);
+#endif
         safeObjectDelete(&ogreRoot_);
         safeObjectDelete(&ogreLogger_);
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.h
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.h	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/core/GraphicsManager.h	(revision 11795)
@@ -52,4 +52,5 @@
 
 #include "util/DestructionHelper.h"
+#include "util/OgreForwardRefs.h"
 #include "util/Singleton.h"
 #include "config/Configurable.h"
@@ -79,6 +80,7 @@
         void postUpdate(const Clock& time);
 
-        Ogre::Viewport* getViewport()         { return this->viewport_; }
-        Ogre::RenderWindow* getRenderWindow() { return this->renderWindow_; }
+        Ogre::Viewport* getViewport()           { return this->viewport_; }
+        Ogre::RenderWindow* getRenderWindow()   { return this->renderWindow_; }
+        Ogre::OverlaySystem* getOverlaySystem() { return this->overlaySystem_; }
         size_t getRenderWindowHandle();
 
@@ -129,4 +131,5 @@
         Ogre::RenderWindow*      renderWindow_;            //!< the one and only render window
         Ogre::Viewport*          viewport_;                //!< default full size viewport
+        Ogre::OverlaySystem*     overlaySystem_;
         GlowMaterialListener*    glowMaterialListener_;    //!< Material Listener for the 'Glow' compositor
         float                    lastFrameStartTime_;      //!< Time stamp of the beginning of the last frame
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/util/DisplayStringConversions.h
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/util/DisplayStringConversions.h	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/util/DisplayStringConversions.h	(revision 11795)
@@ -37,5 +37,10 @@
 
 #include "UtilPrereqs.h"
-#include <OgreOverlayElement.h>
+#include <OgrePrerequisites.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreOverlayElement.h>
+#else
+#   include <OgreOverlayElement.h>
+#endif
 
 #if OGRE_UNICODE_SUPPORT
Index: /code/branches/cegui0.8_ogre1.9/src/libraries/util/OgreForwardRefs.h
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/libraries/util/OgreForwardRefs.h	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/libraries/util/OgreForwardRefs.h	(revision 11795)
@@ -67,5 +67,4 @@
     class Factory;
     class Font;
-    class FontPtr;
     class FontManager;
     struct FrameEvent;
@@ -73,5 +72,4 @@
     class Frustum;
     class GpuProgram;
-    class GpuProgramPtr;
     class GpuProgramManager;
     class GpuProgramUsage;
@@ -82,5 +80,4 @@
     class HardwarePixelBufferSharedPtr;
     class HighLevelGpuProgram;
-    class HighLevelGpuProgramPtr;
     class HighLevelGpuProgramManager;
     class HighLevelGpuProgramFactory;
@@ -96,5 +93,4 @@
     class ManualObject;
     class Material;
-    class MaterialPtr;
     class MaterialManager;
     class MaterialScriptCompiler;
@@ -104,5 +100,4 @@
     class MemoryManager;
     class Mesh;
-    class MeshPtr;
     class MeshSerializer;
     class MeshSerializerImpl;
@@ -120,4 +115,5 @@
     class OverlayElementFactory;
     class OverlayManager;
+    class OverlaySystem;
     class Particle;
     class ParticleAffector;
@@ -179,5 +175,4 @@
     class SimpleSpline;
     class Skeleton;
-    class SkeletonPtr;
     class SkeletonInstance;
     class SkeletonManager;
@@ -195,5 +190,4 @@
     class TextureUnitState;
     class Texture;
-    class TexturePtr;
     class TextureFont;
     class TextureManager;
Index: /code/branches/cegui0.8_ogre1.9/src/modules/designtools/ScreenshotManager.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/designtools/ScreenshotManager.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/designtools/ScreenshotManager.cc	(revision 11795)
@@ -101,5 +101,5 @@
         }
         if(!this->tempTexture_.isNull())
-            this->tempTexture_.freeMethod();
+            this->tempTexture_.setNull();
     }
     
Index: /code/branches/cegui0.8_ogre1.9/src/modules/hover/FlagHUD.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/hover/FlagHUD.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/hover/FlagHUD.cc	(revision 11795)
@@ -32,7 +32,11 @@
 #include "FlagHUD.h"
 
-#include <OgreOverlayManager.h>
-#include <OgreMaterialManager.h>
-#include <OgrePanelOverlayElement.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreOverlayManager.h>
+#   include <Overlay/OgrePanelOverlayElement.h>
+#else
+#   include <OgreOverlayManager.h>
+#   include <OgrePanelOverlayElement.h>
+#endif
 
 #include "util/StringUtils.h"
Index: /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.cc	(revision 11795)
@@ -31,5 +31,4 @@
 #include <OgreEntity.h>
 #include <OgreBillboardSet.h>
-#include <OgreProgressiveMesh.h>
 
 #include "core/CoreIncludes.h"
@@ -47,7 +46,8 @@
      * @brief Constructor
      */
-    Planet::Planet(Context* context) : MovableEntity(context)
+    Planet::Planet(Context* context) : Model(context)
     {
         RegisterObject(Planet);
+        this->setLodEnabled(false);
         this->registerVariables();
     }
@@ -58,6 +58,4 @@
     Planet::~Planet()
     {
-        if (this->isInitialized() && this->mesh_.getEntity())
-            this->detachOgreObject(this->mesh_.getEntity());
     }
 
@@ -87,62 +85,17 @@
     }
 
-    void Planet::changedMesh()
+    void Planet::changedAtmosphere()
     {
         if( GameMode::showsGraphics() )
         {
-            if (this->mesh_.getEntity())
-                this->detachOgreObject(this->mesh_.getEntity());
-
-            this->mesh_.setMeshSource(this->getScene()->getSceneManager(), this->meshSrc_);
-
-            if (this->mesh_.getEntity())
+            if (this->getMesh().getEntity())
             {
-                this->attachOgreObject(this->mesh_.getEntity());
-                this->mesh_.getEntity()->setCastShadows(this->bCastShadows_);
-                this->mesh_.setVisible(this->isVisible());
-
-                float scaleFactor = this->getScale();
-
-#if OGRE_VERSION >= 0x010800
-                Ogre::ProgressiveMesh::LodValueList distList;
-#elif OGRE_VERSION >= 0x010700
-                Ogre::Mesh::LodValueList distList;
-#else
-                Ogre::Mesh::LodDistanceList distList;
-#endif
-
-                distList.push_back(10.0f*scaleFactor);
-                distList.push_back(19.0f*scaleFactor);
-                distList.push_back(27.0f*scaleFactor);
-                distList.push_back(34.0f*scaleFactor);
-                distList.push_back(40.0f*scaleFactor);
-                distList.push_back(45.0f*scaleFactor);
-                distList.push_back(49.0f*scaleFactor);
-                distList.push_back(52.0f*scaleFactor);
-                distList.push_back(54.0f*scaleFactor);
-                distList.push_back(55.0f*scaleFactor);
-
-                float reductionValue = 0.2f;
-
-#if OGRE_VERSION >= 0x010800
-                Ogre::ProgressiveMesh::generateLodLevels(this->mesh_.getEntity()->getMesh().get(), distList, Ogre::ProgressiveMesh::VRQ_PROPORTIONAL,
-                    reductionValue);
-#else
-                this->mesh_.getEntity()->getMesh()->generateLodLevels(distList, Ogre::ProgressiveMesh::VRQ_PROPORTIONAL, reductionValue);
-#endif
-                billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->atmosphere_, Vector3(0,0,0));
+                this->billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->atmosphere_, Vector3(0,0,0));
 
                 this->attachOgreObject(this->billboard_.getBillboardSet());
                 this->billboard_.getBillboardSet()->setUseAccurateFacing(true);
-                this->setCastShadows(true);
-                this->billboard_.getBillboardSet()->setRenderQueueGroup(this->mesh_.getEntity()->getRenderQueueGroup());
-                this->mesh_.setCastShadows(true);
+                this->billboard_.getBillboardSet()->setRenderQueueGroup(this->getMesh().getEntity()->getRenderQueueGroup());
             }
         }
-    }
-
-    void Planet::changedShadows()
-    {
-        this->mesh_.setCastShadows(this->bCastShadows_);
     }
 
@@ -154,16 +107,11 @@
         XMLPortParam(Planet, "atmospheresize", setAtmosphereSize, getAtmosphereSize, xmlelement,mode);
         XMLPortParam(Planet, "imagesize", setImageSize, getImageSize, xmlelement,mode);
-        XMLPortParam(Planet, "mesh", setMeshSource, getMeshSource, xmlelement, mode);
-        XMLPortParam(Planet, "shadow", setCastShadows, getCastShadows, xmlelement, mode).defaultValues(true);
     }
 
     void Planet::registerVariables()
     {
-        registerVariable(this->atmosphere_, VariableDirection::ToClient);
+        registerVariable(this->atmosphere_, VariableDirection::ToClient, new NetworkCallback<Planet>(this, &Planet::changedAtmosphere));
         registerVariable(this->atmosphereSize, VariableDirection::ToClient);
         registerVariable(this->imageSize, VariableDirection::ToClient);
-        // Note: the meshSrc should be synchronised after atmosphere and other values, because the meshSrc callback setts the atmosphere billboards
-        registerVariable(this->meshSrc_, VariableDirection::ToClient, new NetworkCallback<Planet>(this, &Planet::changedMesh));
-        registerVariable(this->bCastShadows_, VariableDirection::ToClient, new NetworkCallback<Planet>(this, &Planet::changedShadows));
     }
 
@@ -171,9 +119,6 @@
     {
         SUPER(Planet, changedVisibility);
-        if (this->isInitialized())
-        {
-            this->mesh_.setVisible(this->isVisible());
-            this->billboard_.setVisible(this->isVisible());
-        }
+
+        this->billboard_.setVisible(this->isVisible());
     }
 }
Index: /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.h
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.h	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/objects/Planet.h	(revision 11795)
@@ -40,10 +40,10 @@
 #include <string>
 #include "tools/BillboardSet.h"
-#include "tools/Mesh.h"
-#include "worldentities/MovableEntity.h"
+#include "tools/interfaces/Tickable.h"
+#include "graphics/Model.h"
 
 namespace orxonox
 {
-    class _ObjectsExport Planet : public MovableEntity
+    class _ObjectsExport Planet : public Model, public Tickable
     {
         public:
@@ -58,20 +58,4 @@
             virtual void changedVisibility() override;
 
-            inline void setMeshSource(const std::string& meshname)
-                { this->meshSrc_ = meshname; this->changedMesh(); }
-
-            inline const std::string& getMeshSource() const
-                { return this->meshSrc_; }
-
-            inline void setCastShadows(bool bCastShadows)
-                { this->bCastShadows_ = bCastShadows; this->changedShadows(); }
-
-            inline bool getCastShadows() const
-                { return this->bCastShadows_; }
-
-            inline const std::string& getMesh() const{
-                return this->meshSrc_;
-            }
-
             inline void setAtmosphereSize(float size){
                 this->atmosphereSize = size;
@@ -84,4 +68,5 @@
             inline void setAtmosphere(const std::string& atmosphere){
                 this->atmosphere_ = atmosphere;
+                this->changedAtmosphere();
             }
 
@@ -103,14 +88,10 @@
             void registerVariables();
 
-            void changedMesh();
-            void changedShadows();
+            void changedAtmosphere();
 
-            std::string meshSrc_;
             std::string atmosphere_;
-            Mesh mesh_;
             float atmosphereSize;
             float imageSize;
             BillboardSet billboard_;
-            bool bCastShadows_;
 
     };
Index: /code/branches/cegui0.8_ogre1.9/src/modules/overlays/FadeoutText.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/overlays/FadeoutText.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/overlays/FadeoutText.cc	(revision 11795)
@@ -29,5 +29,9 @@
 #include "FadeoutText.h"
 
-#include <OgreTextAreaOverlayElement.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreTextAreaOverlayElement.h>
+#else
+#   include <OgreTextAreaOverlayElement.h>
+#endif
 #include "util/Math.h"
 #include "core/CoreIncludes.h"
Index: /code/branches/cegui0.8_ogre1.9/src/modules/overlays/OverlayText.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/overlays/OverlayText.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/overlays/OverlayText.cc	(revision 11795)
@@ -29,7 +29,13 @@
 #include "OverlayText.h"
 
-#include <OgreOverlayManager.h>
-#include <OgrePanelOverlayElement.h>
-#include <OgreTextAreaOverlayElement.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreOverlayManager.h>
+#   include <Overlay/OgrePanelOverlayElement.h>
+#   include <Overlay/OgreTextAreaOverlayElement.h>
+#else
+#   include <OgreOverlayManager.h>
+#   include <OgrePanelOverlayElement.h>
+#   include <OgreTextAreaOverlayElement.h>
+#endif
 
 #include "util/StringUtils.h"
Index: /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.cc
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.cc	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.cc	(revision 11795)
@@ -30,5 +30,10 @@
 
 #include <string>
-#include <OgreTextAreaOverlayElement.h>
+
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreTextAreaOverlayElement.h>
+#else
+#   include <OgreTextAreaOverlayElement.h>
+#endif
 
 #include "util/Convert.h"
Index: /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.h
===================================================================
--- /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.h	(revision 11794)
+++ /code/branches/cegui0.8_ogre1.9/src/modules/overlays/hud/ChatOverlay.h	(revision 11795)
@@ -33,5 +33,11 @@
 
 #include <list>
-#include <OgreOverlayElement.h>
+
+#include <OgrePrerequisites.h>
+#if OGRE_VERSION >= 0x010900
+#   include <Overlay/OgreOverlayElement.h>
+#else
+#   include <OgreOverlayElement.h>
+#endif
 
 #include "chat/ChatListener.h"
